Index: /branches/2018/dev_r8864_nemo_v3_6_ZTILDE/NEMOGCM/NEMO/OPA_SRC/DOM/domvvl.F90
===================================================================
--- /branches/2018/dev_r8864_nemo_v3_6_ZTILDE/NEMOGCM/NEMO/OPA_SRC/DOM/domvvl.F90	(revision 9352)
+++ /branches/2018/dev_r8864_nemo_v3_6_ZTILDE/NEMOGCM/NEMO/OPA_SRC/DOM/domvvl.F90	(revision 9353)
@@ -1401,7 +2047,1069 @@
    END SUBROUTINE dom_vvl_orca_fix
 
+   SUBROUTINE dom_vvl_zdf( kt, p2dt ) 
+      !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE dom_vvl_zdf  ***
+      !!
+      !! ** Purpose :   Do vertical thicknesses anomaly diffusion
+      !!
+      !! ** Method  :  
+      !!
+      !! ** Action  : 
+      !!---------------------------------------------------------------------
+      USE oce     , ONLY:   zwd => ua       , zws => va         ! (ua,va) used as 3D workspace
+      !
+      INTEGER                         , INTENT(in) ::   kt     ! ocean time-step index
+      REAL(wp)                        , INTENT(in) ::   p2dt   ! time step
+      !
+      INTEGER  :: ji, jj, jk ! dummy loop indices
+      REAL(wp) :: zr_tscale
+      REAL(wp) :: za1, za2, za3, za4, zdiff
+      REAL(wp), POINTER, DIMENSION(:,:,:) ::  zwi, zwt
+      !!---------------------------------------------------------------------
+      !
+      IF( nn_timing == 1 )  CALL timing_start('dom_vvl_zdf')
+      !
+      zr_tscale = 0.5
+      !
+      CALL wrk_alloc( jpi, jpj, jpk, zwi, zwt) 
+      !
+      !
+
+      zwt(:,:,1:jpk) = 1.e-10
+
+      zwt(:,:,1) = 0.0_wp
+!      DO jk = 2, jpkm1
+!         DO jj = 1, jpj
+!            DO ji = 1, jpi
+!               zwt(ji,jj,jk) = zwt(ji,jj,jk-1) + (tilde_e3t_a(ji,jj,jk-1)+e3t_0(ji,jj,jk-1)) * tmask(ji,jj,jk-1)
+!            END DO
+!         END DO
+!      END DO
+      !
+      !
+      ! Set diffusivity (homogeneous to an inverse time scale)
+      !
+      DO jk = 2, jpkm1
+         DO jj = 2, jpjm1
+            DO ji = fs_2, fs_jpim1
+! Taper a little bit:
+                za1 = tilde_e3t_n(ji,jj,jk-1)+e3t_0(ji,jj,jk-1)
+                za2 = tilde_e3t_n(ji,jj,jk  )+e3t_0(ji,jj,jk  )
+                za4 = 0.5_wp * (e3t_0(ji,jj,jk-1) + e3t_0(ji,jj,jk  ))
+                za3 = 0.5_wp * (za1 + za2) 
+                zdiff = ABS(za3-za4)/za4
+!                IF (zdiff>=0.8) THEN
+!                   zwt(ji,jj,jk) =  zr_tscale * MIN(zdiff,1._wp) * za3 / p2dt * tmask(ji,jj,jk)
+                   zwt(ji,jj,jk) =  dsm(ji,jj)/ht_0(ji,jj)*(1._wp-tanh((mbkt(ji,jj)+1-jk)*0.2))*tmask(ji,jj,jk)
+
+!                ELSE
+!                   zwt(ji,jj,jk) = 0.e0*tmask(ji,jj,jk)
+!                ENDIF
+            END DO
+         END DO
+      END DO
+      ! 
+      !
+      ! Diagonal, lower (i), upper (s)  (including the bottom boundary condition since avt is masked)
+      DO jk = 1, jpkm1
+         DO jj = 2, jpjm1
+            DO ji = fs_2, fs_jpim1   ! vector opt.
+                zwi(ji,jj,jk) = - p2dt * zwt(ji,jj,jk  ) / fse3w(ji,jj,jk  )
+                zws(ji,jj,jk) = - p2dt * zwt(ji,jj,jk+1) / fse3w(ji,jj,jk+1)
+                zwd(ji,jj,jk) = 1._wp - zwi(ji,jj,jk) - zws(ji,jj,jk)
+            END DO
+         END DO
+      END DO
+      !
+      !! Matrix inversion from the first level
+      !!----------------------------------------------------------------------
+      DO jj = 2, jpjm1
+         DO ji = fs_2, fs_jpim1
+            zwt(ji,jj,1) = zwd(ji,jj,1)
+         END DO
+      END DO
+      DO jk = 2, jpkm1
+         DO jj = 2, jpjm1
+            DO ji = fs_2, fs_jpim1
+               zwt(ji,jj,jk) = zwd(ji,jj,jk) - zwi(ji,jj,jk) * zws(ji,jj,jk-1) / zwt(ji,jj,jk-1)
+            END DO
+         END DO
+      END DO
+      !         
+      ! second recurrence:    Zk = Yk - Ik / Tk-1  Zk-1
+      DO jk = 2, jpkm1
+         DO jj = 2, jpjm1
+            DO ji = fs_2, fs_jpim1
+               tilde_e3t_a(ji,jj,jk) = tilde_e3t_a(ji,jj,jk) - zwi(ji,jj,jk) / zwt(ji,jj,jk-1) * tilde_e3t_a(ji,jj,jk-1)
+            END DO
+         END DO
+      END DO
+      ! third recurrence:    Xk = (Zk - Sk Xk+1 ) / Tk
+      DO jj = 2, jpjm1
+         DO ji = fs_2, fs_jpim1
+            tilde_e3t_a(ji,jj,jpkm1) = tilde_e3t_a(ji,jj,jpkm1) / zwt(ji,jj,jpkm1) * tmask(ji,jj,jpkm1)
+         END DO
+      END DO
+      DO jk = jpk-2, 1, -1
+         DO jj = 2, jpjm1
+            DO ji = fs_2, fs_jpim1
+               tilde_e3t_a(ji,jj,jk) = ( tilde_e3t_a(ji,jj,jk) - zws(ji,jj,jk) * tilde_e3t_a(ji,jj,jk+1) )   &
+                  &            / zwt(ji,jj,jk) * tmask(ji,jj,jk)
+            END DO
+         END DO
+      END DO
+      !
+      CALL wrk_dealloc( jpi, jpj, jpk, zwi, zwt) 
+      !
+      IF( nn_timing == 1 )  CALL timing_stop('dom_vvl_zdf')
+      !
+   END SUBROUTINE dom_vvl_zdf
+
+   SUBROUTINE dom_vvl_zdf2( kt, p2dt ) 
+      !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE dom_vvl_zdf  ***
+      !!
+      !! ** Purpose :   Do vertical interface diffusion
+      !!
+      !! ** Method  :  
+      !!
+      !! ** Action  : 
+      !!---------------------------------------------------------------------
+      USE oce     , ONLY:   zwd => ua       , zws => va         ! (ua,va) used as 3D workspace
+      !
+      INTEGER                         , INTENT(in) ::   kt     ! ocean time-step index
+      REAL(wp)                        , INTENT(in) ::   p2dt   ! time step
+      !
+      INTEGER  :: ji, jj, jk, kbot, kbotm1 ! dummy loop indices
+      REAL(wp) :: zr_tscale
+      REAL(wp) :: za1, za2, za3, za4, zdiff
+      REAL(wp), POINTER, DIMENSION(:,:,:) ::  zwi, zwt, zw
+      !!---------------------------------------------------------------------
+      !
+      IF( nn_timing == 1 )  CALL timing_start('dom_vvl_zdf')
+      !
+      zr_tscale = 0.5
+      !
+      CALL wrk_alloc( jpi, jpj, jpk, zwi, zwt, zw) 
+      !
+      ! Compute internal interfaces depths:
+      zw(:,:,1) = 0._wp
+      DO jk = 2, jpk
+         DO jj = 2, jpjm1
+            DO ji = fs_2, fs_jpim1   ! vector opt.
+               zw(ji,jj,jk) = zw(ji,jj,jk-1) + (tilde_e3t_a(ji,jj,jk-1)+e3t_0(ji,jj,jk-1))  * tmask(ji,jj,jk-1)
+            END DO
+         END DO
+      END DO
+      !
+      ! Set diffusivities at interfaces
+      zwt(:,:,:) = 0.00000001_wp * tmask(:,:,:)      
+      zwt(:,:,1) = 0._wp
+      ! 
+      !
+      ! Diagonal, lower (i), upper (s)  (including the bottom boundary condition since avt is masked)
+      DO jk = 2, jpkm1
+         DO jj = 2, jpjm1
+            DO ji = fs_2, fs_jpim1   ! vector opt.
+                zwi(ji,jj,jk) = - 0.5_wp * p2dt * (zwt(ji,jj,jk-1) + zwt(ji,jj,jk  )) & 
+                              &                   / fse3w(ji,jj,jk-1) / fse3t(ji,jj,jk-1) &
+                              &                   * ht(ji,jj) 
+                zws(ji,jj,jk) = - 0.5_wp * p2dt * (zwt(ji,jj,jk  ) + zwt(ji,jj,jk+1)) & 
+                              &                   / fse3w(ji,jj,jk  ) / fse3t(ji,jj,jk  ) &
+                              &                   * ht(ji,jj) 
+
+                zwd(ji,jj,jk) = 1._wp - zwi(ji,jj,jk) - zws(ji,jj,jk)
+            END DO
+         END DO
+      END DO
+      ! Boundary conditions (Neumann)
+      DO jj = 2, jpjm1
+         DO ji = fs_2, fs_jpim1
+            zwi(ji,jj,1) = 0._wp
+            zws(ji,jj,1) = 0._wp
+            zwd(ji,jj,1) = 1._wp
+            zw (ji,jj,1) = 0._wp
+            !
+            zwd(ji,jj,2) = zwd(ji,jj,2) +  zwi(ji,jj,2)
+            zwi(ji,jj,2) = 0._wp
+!            zwi(ji,jj,2) = 0._wp
+!            zws(ji,jj,2) = 0._wp
+!            zwd(ji,jj,2) = 1._wp
+         END DO
+      END DO
+      DO jj = 2, jpjm1
+         DO ji = fs_2, fs_jpim1
+            kbot   = mbkt(ji,jj) + 1
+            kbotm1 = mbkt(ji,jj)
+            zwi(ji,jj,kbot  ) = 0._wp
+            zws(ji,jj,kbot  ) = 0._wp
+            zwd(ji,jj,kbot  ) = 1._wp
+            !
+            zwd(ji,jj,kbotm1) = zwd(ji,jj,kbotm1) +  zws(ji,jj,kbotm1)
+            zws(ji,jj,kbotm1) = 0._wp
+!            zwi(ji,jj,kbotm1) = 0._wp
+!            zws(ji,jj,kbotm1) = 0._wp
+!            zwd(ji,jj,kbotm1) = 1._wp
+         END DO
+      END DO
+      !
+      DO jk = 2, jpkm1
+         DO jj = 2, jpjm1
+            DO ji = fs_2, fs_jpim1
+               zwd(ji,jj,jk) = zwd(ji,jj,jk) - zwi(ji,jj,jk) * zws(ji,jj,jk-1) / zwd(ji,jj,jk-1)
+            END DO
+         END DO
+      END DO
+      !
+      DO jk = 2, jpk
+         DO jj = 2, jpjm1
+            DO ji = fs_2, fs_jpim1    ! vector opt.
+               zwi(ji,jj,jk) = zw(ji,jj,jk) - zwi(ji,jj,jk) / zwd(ji,jj,jk-1) *zwi(ji,jj,jk-1)
+            END DO
+         END DO
+      END DO
+      !
+      DO jk = jpk-1, 2, -1
+         DO jj = 2, jpjm1
+            DO ji = fs_2, fs_jpim1    ! vector opt.
+               zw(ji,jj,jk) = ( zwi(ji,jj,jk) - zws(ji,jj,jk) * zw(ji,jj,jk+1) ) / zwd(ji,jj,jk)
+            END DO
+         END DO
+      END DO
+      !
+      ! Revert to thicknesses anomalies:
+      DO jk = 1, jpkm1
+         DO jj = 2, jpjm1
+            DO ji = fs_2, fs_jpim1   ! vector opt.
+               tilde_e3t_a(ji,jj,jk) = (zw(ji,jj,jk+1)-zw(ji,jj,jk)-e3t_0(ji,jj,jk))* tmask(ji,jj,jk)
+            END DO
+         END DO
+      END DO
+      !
+      CALL wrk_dealloc( jpi, jpj, jpk, zwi, zwt, zw) 
+      !
+      IF( nn_timing == 1 )  CALL timing_stop('dom_vvl_zdf')
+      !
+   END SUBROUTINE dom_vvl_zdf2
+
+   SUBROUTINE dom_vvl_regrid( kt )
+      !!----------------------------------------------------------------------
+      !!                ***  ROUTINE dom_vvl_regrid  ***
+      !!                   
+      !! ** Purpose :  Ensure "well-behaved" vertical grid
+      !!
+      !! ** Method  :  More or less adapted from references below.
+      !!
+      !! ** Action  :  Ensure that thickness are above a given value, spaced enough
+      !!               and revert to Eulerian coordinates near the bottom.      
+      !!
+      !! References :  Bleck, R. and S. Benjamin, 1993: Regional Weather Prediction
+      !!               with a Model Combining Terrain-following and Isentropic
+      !!               coordinates. Part I: Model Description. Monthly Weather Rev.,
+      !!               121, 1770-1785.
+      !!               Toy, M., 2011: Incorporating Condensational Heating into a
+      !!               Nonhydrostatic Atmospheric Model Based on a Hybrid Isentropic-
+      !!               Sigma Vertical Coordinate. Monthly Weather Rev., 139, 2940-2954.
+      !!----------------------------------------------------------------------
+      !! * Arguments
+      INTEGER, INTENT( in )               :: kt         ! time step
+
+      !! * Local declarations
+      INTEGER                             :: ji, jj, jk ! dummy loop indices
+      LOGICAL                             :: ll_chk_bot2top, ll_chk_top2bot, ll_lapdiff_cond
+      LOGICAL                             :: ll_e3tsurf_const, ll_zdiff_cond, ll_blpdiff_cond
+      INTEGER                             :: jkbot
+      REAL(wp)                            :: zh_min, zh_0, zh2, zdiff, zh_max, ztmph, ztmpd, dzmin_vvl
+      REAL(wp)                            :: zufim1, zufi, zvfjm1, zvfj
+      REAL(wp)                            :: zh_new, zh_old, zh_bef, ztmp, ztmp1, z2dt, zh_up, zh_dwn
+      REAL(wp)                            :: zeu2, zev2, zfrch_stp, zfrch_rel, zfrac_bot, zscal_bot
+      REAL(wp)                            :: zhdiff, zhdiff2, zvdiff, zhlim, zhlim2, zvlim
+      REAL(wp), POINTER, DIMENSION(:,:)   :: zdw
+      REAL(wp), POINTER, DIMENSION(:,:,:) :: zwdw, zwdw_b
+      !!----------------------------------------------------------------------
+
+      IF( nn_timing == 1 )  CALL timing_start('dom_vvl_regrid')
+      !
+      CALL wrk_alloc( jpi, jpj, jpk, zwdw) 
+      !
+      ! Some user defined parameters below:
+      ll_chk_bot2top   = .TRUE.
+      ll_chk_top2bot   = .TRUE.
+      ll_e3tsurf_const = .FALSE.
+      dzmin_vvl  = 1._wp   ! Absolute minimum depth (in meters)
+      zfrch_stp  = 0.5_wp   ! Maximum fractionnal thickness change in one time step (<= 1.)
+      zfrch_rel  = 0.0_wp   ! Maximum relative thickness change in the vertical (<= 1.)
+      zfrac_bot  = 0.01_wp  ! Fraction of bottom level allowed to change
+      zscal_bot  = 2._wp    ! Depth lengthscale
+      ll_zdiff_cond    = .FALSE.  ! Conditionnal vertical diffusion of interfaces
+         zvdiff  = 0.1_wp   ! m/s
+         zvlim   = 0.4_wp   ! max d2h/dh
+      ll_lapdiff_cond  = .FALSE.  ! Conditionnal Laplacian diffusion of interfaces
+         zhdiff  = 0.1_wp   ! ad.
+         zhlim   = 0.01_wp  ! max lap(z)/e1
+      ll_blpdiff_cond  = .FALSE.  ! Conditionnal Bilaplacian diffusion of interfaces
+         zhdiff2 = 0.8_wp   ! ad.
+         zhlim2  = 5.e-11_wp  ! max bilap(z)/e1**3
+      ! --------------------------------------------------------------------------------------- 
+      !
+      ! Set arrays determining maximum vertical displacement at the bottom:
+      !--------------------------------------------------------------------
+      IF ( kt==nit000 ) THEN
+         DO jj = 2, jpjm1
+            DO ji = 2, jpim1
+               jk = MIN(mbkt(ji,jj), mbkt(ji+1,jj), mbkt(ji-1,jj), mbkt(ji,jj+1), mbkt(ji,jj-1))
+               i_int_bot(ji,jj) = jk
+            END DO
+         END DO
+         dsm(:,:) = REAL( i_int_bot(:,:), wp )   ;   CALL lbc_lnk(dsm(:,:),'T',1.)
+         i_int_bot(:,:) = MAX( INT( dsm(:,:) ), 1 )
+
+         CALL wrk_alloc( jpi, jpj, zdw )
+         DO jj = 2, jpjm1
+            DO ji = 2, jpim1
+               zdw(ji,jj) = MAX(ABS(ht_0(ji,jj)-ht_0(ji+1,jj))*umask(ji  ,jj,1), &
+                          &     ABS(ht_0(ji,jj)-ht_0(ji-1,jj))*umask(ji-1,jj,1), &
+                          &     ABS(ht_0(ji,jj)-ht_0(ji,jj+1))*vmask(ji,jj  ,1), &
+                          &     ABS(ht_0(ji,jj)-ht_0(ji,jj-1))*vmask(ji,jj-1,1)  )
+               zdw(ji,jj) = MAX(zscal_bot * zdw(ji,jj), rsmall ) 
+            END DO
+         END DO
+         CALL lbc_lnk( zdw(:,:), 'T', 1. )
+
+         DO jj = 2, jpjm1
+            DO ji = 2, jpim1
+               dsm(ji,jj) = 1._wp/16._wp * (            zdw(ji-1,jj-1) + zdw(ji+1,jj-1)      &
+                  &                           +         zdw(ji-1,jj+1) + zdw(ji+1,jj+1)      &
+                  &                           + 2._wp*( zdw(ji  ,jj-1) + zdw(ji-1,jj  )      &
+                  &                           +         zdw(ji+1,jj  ) + zdw(ji  ,jj+1) )    &
+                  &                           + 4._wp*  zdw(ji  ,jj  )                       )
+            END DO
+         END DO
+
+         CALL lbc_lnk( dsm(:,:), 'T', 1. )
+         CALL wrk_dealloc( jpi, jpj, zdw)         
+     
+         IF (ln_zps) THEN
+            DO jj = 1, jpj
+               DO ji = 1, jpi
+                  jk = i_int_bot(ji,jj)
+                  hsm(ji,jj) = zfrac_bot * e3w_1d(jk)
+               END DO
+            END DO
+         ELSE
+            DO jj = 1, jpj
+               DO ji = 1, jpi
+                  jk = i_int_bot(ji,jj)
+                  hsm(ji,jj) = zfrac_bot * e3w_0(ji,jj,jk)
+               END DO
+            END DO
+         ENDIF
+      END IF
+
+      ! Provisionnal interface depths:
+      !-------------------------------
+      zwdw(:,:,1) = 0.e0
+      DO jj = 1, jpj
+         DO ji = 1, jpi
+            DO jk = 2, jpk
+               zwdw(ji,jj,jk) =  zwdw(ji,jj,jk-1) + & 
+                              & (tilde_e3t_a(ji,jj,jk-1)+e3t_0(ji,jj,jk-1)) * tmask(ji,jj,jk-1)
+            END DO
+         END DO
+      END DO
+      !
+      ! Conditionnal horizontal Laplacian diffusion:
+      !---------------------------------------------
+      IF ( ll_lapdiff_cond ) THEN
+         CALL wrk_alloc( jpi, jpj, jpk, zwdw_b)
+         !
+         zwdw_b(:,:,1) = 0._wp
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               DO jk=2,jpk
+                  zwdw_b(ji,jj,jk) =  zwdw_b(ji,jj,jk-1) + & 
+                                   & (tilde_e3t_b(ji,jj,jk-1)+e3t_0(ji,jj,jk-1)) * tmask(ji,jj,jk-1)
+               END DO
+            END DO
+         END DO
+         !
+         DO jk = 2, jpkm1
+            DO jj = 1, jpjm1
+               DO ji = 1, fs_jpim1   ! vector opt.                  
+                  ua(ji,jj,jk) =  umask(ji,jj,jk) * re2u_e1u(ji,jj) &
+                                  &  * ( zwdw_b(ji,jj,jk) - zwdw_b(ji+1,jj  ,jk) )
+                  va(ji,jj,jk) =  vmask(ji,jj,jk) * re1v_e2v(ji,jj) & 
+                                  &  * ( zwdw_b(ji,jj,jk) - zwdw_b(ji  ,jj+1,jk) )
+               END DO
+            END DO
+         END DO
+            
+         DO jk = 2, jpkm1
+            DO jj = 2, jpjm1
+               DO ji = fs_2, fs_jpim1   ! vector opt.
+                  ztmp1 = ( (ua(ji-1,jj  ,jk) - ua(ji,jj,jk))    &
+                     &  +   (va(ji  ,jj-1,jk) - va(ji,jj,jk)) ) * r1_e12t(ji,jj)
+                  zh2 = MAX(abs(ztmp1)-zhlim*SQRT(r1_e12t(ji,jj)), 0._wp)
+                  ztmp = SIGN(zh2, ztmp1)
+                  zeu2 = zhdiff * e12t(ji,jj)*e12t(ji,jj)/(e1t(ji,jj)*e1t(ji,jj) + e2t(ji,jj)*e2t(ji,jj))
+                  zwdw(ji,jj,jk) = zwdw(ji,jj,jk) + zeu2 * ztmp *  tmask(ji,jj,jk)
+               END DO
+            END DO
+         END DO         
+         !
+         CALL wrk_dealloc( jpi, jpj, jpk, zwdw_b)
+         !
+      ENDIF
+
+      ! Conditionnal horizontal Bilaplacian diffusion:
+      !-----------------------------------------------
+      IF ( ll_blpdiff_cond ) THEN
+         CALL wrk_alloc( jpi, jpj, jpk, zwdw_b)
+         !
+         zwdw_b(:,:,1) = 0._wp
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               DO jk=2,jpk
+                  zwdw_b(ji,jj,jk) =  zwdw_b(ji,jj,jk-1) + & 
+                                   & (tilde_e3t_b(ji,jj,jk-1)+e3t_0(ji,jj,jk-1)) * tmask(ji,jj,jk-1)
+               END DO
+            END DO
+         END DO
+         !
+         DO jk = 2, jpkm1
+            DO jj = 1, jpjm1
+               DO ji = 1, fs_jpim1   ! vector opt.                  
+                  ua(ji,jj,jk) =  umask(ji,jj,jk) * re2u_e1u(ji,jj) &
+                                  &  * ( zwdw_b(ji,jj,jk) - zwdw_b(ji+1,jj  ,jk) )
+                  va(ji,jj,jk) =  vmask(ji,jj,jk) * re1v_e2v(ji,jj) & 
+                                  &  * ( zwdw_b(ji,jj,jk) - zwdw_b(ji  ,jj+1,jk) )
+               END DO
+            END DO
+         END DO
+            
+         DO jk = 2, jpkm1
+            DO jj = 2, jpjm1
+               DO ji = fs_2, fs_jpim1   ! vector opt.
+                  zwdw_b(ji,jj,jk) = -( (ua(ji-1,jj  ,jk) - ua(ji,jj,jk))    &
+                                &  +    (va(ji  ,jj-1,jk) - va(ji,jj,jk)) ) * r1_e12t(ji,jj)
+               END DO
+            END DO
+         END DO   
+         !
+         CALL lbc_lnk( zwdw_b(:,:,:), 'T', 1. )      
+         !
+         DO jk = 2, jpkm1
+            DO jj = 1, jpjm1
+               DO ji = 1, fs_jpim1   ! vector opt.                  
+                  ua(ji,jj,jk) =  umask(ji,jj,jk) * re2u_e1u(ji,jj) &
+                                  &  * ( zwdw_b(ji,jj,jk) - zwdw_b(ji+1,jj  ,jk) )
+                  va(ji,jj,jk) =  vmask(ji,jj,jk) * re1v_e2v(ji,jj) & 
+                                  &  * ( zwdw_b(ji,jj,jk) - zwdw_b(ji  ,jj+1,jk) )
+               END DO
+            END DO
+         END DO
+         !   
+         DO jk = 2, jpkm1
+            DO jj = 2, jpjm1
+               DO ji = fs_2, fs_jpim1   ! vector opt.
+                  ztmp1 = ( (ua(ji-1,jj  ,jk) - ua(ji,jj,jk))    &
+                     &  +   (va(ji  ,jj-1,jk) - va(ji,jj,jk)) ) * r1_e12t(ji,jj)
+                  zh2 = MAX(abs(ztmp1)-zhlim2, 0._wp)
+                  ztmp = SIGN(zh2, ztmp1)
+                  zeu2 = zhdiff2 * e12t(ji,jj)*e12t(ji,jj) / 16._wp
+                  zwdw(ji,jj,jk) = zwdw(ji,jj,jk) + zeu2 * ztmp *  tmask(ji,jj,jk)
+               END DO
+            END DO
+         END DO   
+         !
+         CALL wrk_dealloc( jpi, jpj, jpk, zwdw_b)
+         !
+      ENDIF
+
+      ! Conditionnal vertical diffusion:
+      !---------------------------------
+      IF ( ll_zdiff_cond ) THEN
+         DO jk = 2, jpkm1
+            DO jj = 2, jpjm1
+               DO ji = fs_2, fs_jpim1   ! vector opt.    
+                  ztmp  = -( (tilde_e3t_b(ji,jj,jk-1)+e3t_0(ji,jj,jk-1))*tmask(ji,jj,jk-1) & 
+                            -(tilde_e3t_b(ji,jj,jk  )+e3t_0(ji,jj,jk  ))*tmask(ji,jj,jk  ) ) 
+                  ztmp1 = 0.5_wp * ( tilde_e3t_b(ji,jj,jk-1) + e3t_0(ji,jj,jk-1) & 
+                        &           +tilde_e3t_b(ji,jj,jk  ) + e3t_0(ji,jj,jk  ) )
+                  zh2   = MAX(abs(ztmp)-zvlim*ztmp1, 0._wp)
+                  ztmp  = SIGN(zh2, ztmp)
+                  IF ((jk==mbkt(ji,jj)).AND.(ln_zps)) ztmp=0.e0
+                  zwdw(ji,jj,jk) = zwdw(ji,jj,jk) + zvdiff * ztmp * tmask(ji,jj,jk)
+               END DO
+            END DO
+         END DO
+      ENDIF
+      !
+      ! Check grid from the bottom to the surface
+      !------------------------------------------
+      IF ( ll_chk_bot2top ) THEN
+         DO jj = 2, jpjm1
+            DO ji = 2, jpim1
+               jkbot = mbkt(ji,jj)                   
+               DO jk = jkbot,2,-1
+                  !
+                  zh_0   = e3t_0(ji,jj,jk)
+                  zh_bef = MIN(tilde_e3t_b(ji,jj,jk) + zh_0, tilde_e3t_b(ji,jj,jk-1) + e3t_0(ji,jj,jk-1))
+                  zh_old = tilde_e3t_a(ji,jj,jk  ) + zh_0
+!                  zh_dwn = tilde_e3t_a(ji,jj,jk+1) + e3t_0(ji,jj,jk+1)
+                  zh_min = MIN(zh_0/3._wp, dzmin_vvl)
+                  ! 
+                  ! Set maximum and minimum vertical excursions   
+                  ztmph = hsm(ji,jj)
+                  ztmpd = dsm(ji,jj)
+                  zh2   = ztmph * exp(-(gdepw_0(ji,jj,jk)-gdepw_0(ji,jj,i_int_bot(ji,jj)+1))/ztmpd)               
+                  zdiff = cush_max(gdepw_0(ji,jj,jk)-zwdw(ji,jj,jk), zh2 )
+                  zwdw(ji,jj,jk) = MAX(zwdw(ji,jj,jk), gdepw_0(ji,jj,jk) - zdiff)
+                  zdiff = cush_max(zwdw(ji,jj,jk)-gdepw_0(ji,jj,jk), zh2 )
+                  zwdw(ji,jj,jk) = MIN(zwdw(ji,jj,jk), gdepw_0(ji,jj,jk) + zdiff)
+                  !
+                  ! New layer thickness:
+                  zh_new =  zwdw(ji,jj,jk+1) - zwdw(ji,jj,jk)
+                  !
+                  ! Ensure minimum layer thickness:                  
+!                  zh_new = MIN(zh_old, zh_dwn * zfrch_rel / (2._wp-zfrch_rel) )
+                  zh_new = cush(zh_new, zh_min)
+                  !
+                  ! Final flux:
+                  zdiff = (zh_new - zh_old) * tmask(ji,jj,jk)
+                  !
+                  ! Limit flux: 
+                  ztmp = MIN( ABS(zdiff), zfrch_stp*zh_bef )
+                  zdiff = SIGN(ztmp, zh_new - zh_old)
+                  zh_new = zdiff + zh_old
+                  !
+                  tilde_e3t_a(ji,jj,jk  ) = (zh_new - e3t_0(ji,jj,jk)) * tmask(ji,jj,jk)
+                  zwdw(ji,jj,jk)          = zwdw(ji,jj,jk+1) - zh_new
+                  tilde_e3t_a(ji,jj,jk-1) = (-zdiff + tilde_e3t_a(ji,jj,jk-1) ) * tmask(ji,jj,jk-1)            
+               END DO    
+            END DO 
+         END DO
+      END IF    
+      !
+      ! Check grid from the surface to the bottom 
+      !------------------------------------------ 
+      IF ( ll_chk_top2bot ) THEN      
+         DO jj = 2, jpjm1
+            DO ji = 2, jpim1
+               jkbot = mbkt(ji,jj)   
+               DO jk = 1, jkbot-1
+                  !
+                  zh_0   = e3t_0(ji,jj,jk)
+                  zh_bef = MIN(tilde_e3t_b(ji,jj,jk) + zh_0, tilde_e3t_b(ji,jj,jk+1) + e3t_0(ji,jj,jk+1))
+                  zh_old = tilde_e3t_a(ji,jj,jk  ) + zh_0   
+!                  zh_up  = tilde_e3t_a(ji,jj,jk-1) + e3t_0(ji,jj,jk-1)
+                  zh_min = MIN(zh_0/3._wp, dzmin_vvl)
+                  IF ((jk<=5).AND.ll_e3tsurf_const) zh_min = MAX(e3t_0(ji,jj,1)/3._wp, dzmin_vvl)
+                  !
+                  ! Ensure minimum layer thickness:
+!                  zh_new=MIN(zh_old, zh_up * zfrch_rel / (2._wp-zfrch_rel) )
+                  zh_new = cush(zh_old, zh_min)
+                  !
+                  ! Final flux:
+                  zdiff = (zh_new -zh_old) * tmask(ji,jj,jk)
+                  ! 
+                  ! Limit flux:                 
+                  ztmp = MIN( ABS(zdiff), zfrch_stp*zh_bef )
+                  zdiff = SIGN(ztmp, zdiff)
+                  zh_new = zdiff + zh_old
+                  !
+                  tilde_e3t_a(ji,jj,jk  ) = (zh_new - e3t_0(ji,jj,jk)) * tmask(ji,jj,jk)
+                  zwdw(ji,jj,jk+1)        = zwdw(ji,jj,jk) + zh_new
+                  tilde_e3t_a(ji,jj,jk+1) = (-zdiff + tilde_e3t_a(ji,jj,jk+1) ) * tmask(ji,jj,jk+1)
+               END DO
+               !               
+            END DO
+         END DO
+      ENDIF
+      !
+      CALL wrk_dealloc( jpi, jpj, jpk, zwdw ) 
+      !
+      IF( nn_timing == 1 )  CALL timing_stop('dom_vvl_regrid')
+      !
+   END SUBROUTINE dom_vvl_regrid
+
+   FUNCTION cush(hin, hmin)  RESULT(hout)
+      !!----------------------------------------------------------------------
+      !!                 ***  FUNCTION cush  ***
+      !!
+      !! ** Purpose :   
+      !!
+      !! ** Method  :
+      !!
+      !!----------------------------------------------------------------------
+      IMPLICIT NONE
+      REAL(wp), INTENT(in) ::  hin, hmin
+      REAL(wp)             ::  hout, zx, zh_cri
+      !!----------------------------------------------------------------------
+      zh_cri = 3._wp * hmin
+      !
+      IF ( hin<=0._wp ) THEN
+         hout = hmin
+      !
+      ELSEIF ( (hin>0._wp).AND.(hin<=zh_cri) ) THEN
+         zx = hin/zh_cri
+         hout = hmin * (1._wp + zx + zx*zx)      
+      !
+      ELSEIF ( hin>zh_cri ) THEN
+         hout = hin
+      !
+      ENDIF
+      !
+   END FUNCTION cush
+
+   FUNCTION cush_max(hin, hmax)  RESULT(hout)
+      !!----------------------------------------------------------------------
+      !!                 ***  FUNCTION cush  ***
+      !!
+      !! ** Purpose :   
+      !!
+      !! ** Method  :
+      !!
+      !!----------------------------------------------------------------------
+      IMPLICIT NONE
+      REAL(wp), INTENT(in) ::  hin, hmax
+      REAL(wp)             ::  hout, hmin, zx, zh_cri
+      !!----------------------------------------------------------------------
+      hmin = 0.1_wp * hmax
+      zh_cri = 3._wp * hmin
+      !
+      IF ( (hin>=(hmax-zh_cri)).AND.(hin<=(hmax-hmin))) THEN
+         zx = (hmax-hin)/zh_cri
+         hout = hmax - hmin * (1._wp + zx + zx*zx)
+         !
+      ELSEIF ( hin>(hmax-zh_cri) ) THEN
+         hout = hmax - hmin
+         !
+      ELSE
+         hout = hin
+         !
+      ENDIF
+      !
+   END FUNCTION cush_max
+
+   SUBROUTINE dom_vvl_adv_fct( kt, pta, uin, vin )
+      !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE dom_vvl_adv_fct  ***
+      !! 
+      !! **  Purpose :  Do thickness advection
+      !!
+      !! **  Method  :  FCT scheme to ensure positivity 
+      !!
+      !! **  Action  : - Update pta thickness tendency and diffusive fluxes
+      !!               - this is the total trend, hence it does include sea level motions
+      !!               - Upstream corrections to antidiffusive fluxes ensure
+      !!                 that barotropic transport matches what is contained in input fluxes
+      !!----------------------------------------------------------------------
+      !
+      INTEGER, INTENT( in ) ::   kt   ! ocean time-step index
+      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(inout) ::   pta    ! thickness baroclinic trend 
+      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(in)    ::   uin, vin  ! input velocities
+      !
+      INTEGER  ::   ji, jj, jk               ! dummy loop indices  
+      INTEGER  ::   ikbu, ikbv, ibot
+      REAL(wp) ::   z2dtt, zbtr, ztra        ! local scalar
+      REAL(wp) ::   zdi, zdj, zmin           !   -      -
+      REAL(wp) ::   zfp_ui, zfp_vj           !   -      -
+      REAL(wp) ::   zfm_ui, zfm_vj           !   -      -
+      REAL(wp) ::   zfp_hi, zfp_hj           !   -      -
+      REAL(wp) ::   zfm_hi, zfm_hj           !   -      -
+      REAL(wp), POINTER, DIMENSION(:,:)   :: zbu, zbv, zhu_b, zhv_b
+      REAL(wp), POINTER, DIMENSION(:,:,:) :: zwx, zwy, zwi
+      !!----------------------------------------------------------------------
+      !
+      IF( nn_timing == 1 )  CALL timing_start('dom_vvl_adv_fct')
+      !
+      CALL wrk_alloc( jpi, jpj, zhu_b, zhv_b, zbu, zbv)
+      CALL wrk_alloc( jpi, jpj, jpk, zwx, zwy, zwi)
+      !
+      ! 1. Initializations
+      ! ------------------
+      !
+      IF( neuler == 0 .AND. kt == nit000 ) THEN
+         z2dtt =  rdt
+      ELSE
+         z2dtt = 2.0_wp * rdt
+      ENDIF
+      !
+      zwi(:,:,:) = 0.e0
+      zwx(:,:,:) = 0.e0 
+      zwy(:,:,:) = 0.e0
+      !
+      !
+      ! 2. upstream advection with initial mass fluxes & intermediate update
+      ! --------------------------------------------------------------------
+      DO jk = 1, jpkm1
+         DO jj = 1, jpjm1
+            DO ji = 1, fs_jpim1   ! vector opt.
+               !
+               zfp_ui = uin(ji,jj,jk) + ABS( uin(ji,jj,jk) )
+               zfm_ui = uin(ji,jj,jk) - ABS( uin(ji,jj,jk) )
+               zfp_hi = fse3t_b(ji  ,jj  ,jk)
+               zfm_hi = fse3t_b(ji+1,jj  ,jk)
+               zwx(ji,jj,jk) = 0.5 * e2u(ji,jj) * ( zfp_ui * zfp_hi + zfm_ui * zfm_hi ) * umask(ji,jj,jk)
+               !
+               zfp_vj = vin(ji,jj,jk) + ABS( vin(ji,jj,jk) )
+               zfm_vj = vin(ji,jj,jk) - ABS( vin(ji,jj,jk) )
+               zfp_hj = fse3t_b(ji  ,jj  ,jk)
+               zfm_hj = fse3t_b(ji  ,jj+1,jk)
+               zwy(ji,jj,jk) = 0.5 * e1v(ji,jj) * ( zfp_vj * zfp_hj + zfm_vj * zfm_hj ) * vmask(ji,jj,jk)
+            END DO
+         END DO
+      END DO
+
+      IF ( .NOT.ln_sco ) THEN
+         ! Correct bottom upstream fluxes
+         ! considering "shelf horizon depths"
+         DO jj = 1, jpjm1
+            DO ji = 1, fs_jpim1   ! vector opt.
+               ! upstream scheme
+               ikbu = mbku(ji,jj)
+               ikbv = mbkv(ji,jj)
+               zfp_ui = uin(ji,jj,ikbu) + ABS( uin(ji,jj,ikbu) )
+               zfm_ui = uin(ji,jj,ikbu) - ABS( uin(ji,jj,ikbu) )
+               zfp_hi = MAX(hu_b(ji,jj) - fsdepw_b(ji  ,jj  ,ikbu), 0._wp)
+               zfm_hi = MAX(hu_b(ji,jj) - fsdepw_b(ji+1,jj  ,ikbu), 0._wp)
+               zwx(ji,jj,ikbu) = 0.5 * e2u(ji,jj) * ( zfp_ui * zfp_hi + zfm_ui * zfm_hi ) * umask(ji,jj,ikbu)
+               !
+               zfp_vj = vin(ji,jj,ikbv) + ABS( vin(ji,jj,ikbv) )
+               zfm_vj = vin(ji,jj,ikbv) - ABS( vin(ji,jj,ikbv) )
+               zfp_hj = MAX(hv_b(ji,jj) - fsdepw_b(ji  ,jj  ,ikbv), 0._wp)
+               zfm_hj = MAX(hv_b(ji,jj) - fsdepw_b(ji  ,jj+1,ikbv), 0._wp)
+               zwy(ji,jj,ikbv) = 0.5 * e1v(ji,jj) * ( zfp_vj * zfp_hj + zfm_vj * zfm_hj ) * vmask(ji,jj,ikbv)
+            END DO
+         END DO
+      ENDIF
+
+      ! total advective trend
+      DO jk = 1, jpkm1
+         DO jj = 2, jpjm1
+            DO ji = fs_2, fs_jpim1   ! vector opt.
+               zbtr = r1_e12t(ji,jj)
+               ! total intermediate advective trends
+               ztra = - zbtr * (  zwx(ji,jj,jk) - zwx(ji-1,jj  ,jk  )  &
+                  &             + zwy(ji,jj,jk) - zwy(ji  ,jj-1,jk  )  )
+               !
+               ! update and guess with monotonic sheme
+               pta(ji,jj,jk) =   pta(ji,jj,jk) + ztra
+               zwi(ji,jj,jk) = (fse3t_b(ji,jj,jk) + z2dtt * ztra ) * tmask(ji,jj,jk)
+            END DO
+         END DO
+      END DO
+      !                             ! Lateral boundary conditions on zwi  (unchanged sign)
+      CALL lbc_lnk( zwi, 'T', 1. )  
+
+      IF ( ln_vvl_dbg ) THEN
+         zmin = MINVAL( zwi(:,:,:), mask = tmask(:,:,:) == 1.e0 ) 
+         IF( lk_mpp )   CALL mpp_min( zmin )
+         IF( zmin < 0._wp) THEN
+            IF(lwp) CALL ctl_stop('vvl_adv: CFL issue here')
+         ENDIF
+      ENDIF
+
+      ! 3. antidiffusive flux : high order minus low order
+      ! --------------------------------------------------
+      ! antidiffusive flux on i and j
+      DO jk = 1, jpkm1
+         DO jj = 1, jpjm1
+            DO ji = 1, fs_jpim1   ! vector opt.
+               zwx(ji,jj,jk) = (e2u(ji,jj) * uin(ji,jj,jk) * fse3u_n(ji,jj,jk) &
+                                & - zwx(ji,jj,jk)) * umask(ji,jj,jk)
+               zwy(ji,jj,jk) = (e1v(ji,jj) * vin(ji,jj,jk) * fse3v_n(ji,jj,jk) & 
+                                & - zwy(ji,jj,jk)) * vmask(ji,jj,jk)
+               !
+               ! Update advective fluxes
+               un_td(ji,jj,jk) = un_td(ji,jj,jk) - zwx(ji,jj,jk)
+               vn_td(ji,jj,jk) = vn_td(ji,jj,jk) - zwy(ji,jj,jk)
+            END DO
+         END DO
+      END DO
+      
+      CALL lbc_lnk( zwx, 'U', -1. )   ;   CALL lbc_lnk( zwy, 'V', -1. )         ! Lateral boundary conditions
+
+      ! 4. monotonicity algorithm
+      ! -------------------------
+      CALL nonosc_2d( fse3t_b(:,:,:), zwx, zwy, zwi, z2dtt )
+
+      ! 5. final trend with corrected fluxes
+      ! ------------------------------------
+      !
+      ! Update advective fluxes
+      un_td(:,:,:) = (un_td(:,:,:) + zwx(:,:,:))*umask(:,:,:)
+      vn_td(:,:,:) = (vn_td(:,:,:) + zwy(:,:,:))*vmask(:,:,:)
+      !
+      DO jk = 1, jpkm1
+         DO jj = 2, jpjm1
+            DO ji = fs_2, fs_jpim1   ! vector opt.  
+               !
+               zbtr = r1_e12t(ji,jj)
+               ztra = - zbtr * (  zwx(ji,jj,jk) - zwx(ji-1,jj  ,jk  )   &
+                  &             + zwy(ji,jj,jk) - zwy(ji  ,jj-1,jk  ) )
+               ! add them to the general tracer trends
+               pta(ji,jj,jk) = pta(ji,jj,jk) + ztra
+            END DO
+         END DO
+      END DO
+
+      !
+      ! 6. Correct barotropic flux
+      ! --------------------------
+      ! Compute barotropic flux difference:
+      zbu(:,:) = 0.e0
+      zbv(:,:) = 0.e0
+      DO jj = 1, jpj
+         DO ji = 1, jpi   ! vector opt.
+            DO jk = 1, jpkm1
+               zbu(ji,jj) = zbu(ji,jj) - un_td(ji,jj,jk) * umask(ji,jj,jk)
+               zbv(ji,jj) = zbv(ji,jj) - vn_td(ji,jj,jk) * vmask(ji,jj,jk)
+            END DO
+         END DO
+      ENDDO
+
+      ! Compute upstream depths:
+      zhu_b(:,:) = 0.e0
+      zhv_b(:,:) = 0.e0
+      IF ( ln_sco ) THEN; ibot=0 ; ELSE ; ibot=1 ; ENDIF
+
+      DO jj = 1, jpjm1
+         DO ji = 1, jpim1   ! vector opt.
+            zdi = 0.5_wp + 0.5_wp * SIGN(1._wp, zbu(ji,jj))
+            ikbu = mbku(ji,jj) - ibot 
+            DO jk = 1, ikbu
+               zfp_hi = fse3t_b(ji  ,jj  ,jk)
+               zfm_hi = fse3t_b(ji+1,jj  ,jk)
+               zhu_b(ji,jj) = zhu_b(ji,jj) + (          zdi  * zfp_hi &
+                            &                  + (1._wp-zdi) * zfm_hi &
+                            &                ) * umask(ji,jj,jk)
+            END DO
+            !
+            zdj = 0.5_wp + 0.5_wp * SIGN(1._wp, zbv(ji,jj))
+            ikbv = mbkv(ji,jj) - ibot
+            DO jk = 1, ikbv
+               zfp_hj = fse3t_b(ji  ,jj  ,jk)
+               zfm_hj = fse3t_b(ji  ,jj+1,jk)
+               zhv_b(ji,jj) = zhv_b(ji,jj) + (          zdj  * zfp_hj &
+                            &                  + (1._wp-zdj) * zfm_hj &
+                            &                ) * vmask(ji,jj,jk)
+            END DO
+         END DO
+      END DO
+
+      IF ( .NOT.ln_sco ) THEN
+         ! Correct bottom value
+         ! considering "shelf horizon depth"
+         DO jj = 1, jpjm1
+            DO ji = 1, jpim1   ! vector opt.
+               zdi = 0.5_wp + 0.5_wp * SIGN(1._wp, zbu(ji,jj))
+               zdj = 0.5_wp + 0.5_wp * SIGN(1._wp, zbv(ji,jj))
+               ikbu = mbku(ji,jj)
+               ikbv = mbkv(ji,jj)
+               zfp_hi = MAX(hu_b(ji,jj) - fsdepw_b(ji  ,jj  ,ikbu), 0._wp)
+               zfm_hi = MAX(hu_b(ji,jj) - fsdepw_b(ji+1,jj  ,ikbu), 0._wp)
+               zfp_hj = MAX(hv_b(ji,jj) - fsdepw_b(ji  ,jj  ,ikbv), 0._wp)
+               zfm_hj = MAX(hv_b(ji,jj) - fsdepw_b(ji  ,jj+1,ikbv), 0._wp)
+               zhu_b(ji,jj) = zhu_b(ji,jj) + (         zdi  * zfp_hi &
+                            &                 + (1._wp-zdi) * zfm_hi &
+                            &                ) * umask(ji,jj,ikbu)
+               zhv_b(ji,jj) = zhv_b(ji,jj) + (         zdj  * zfp_hj &
+                            &                 + (1._wp-zdj) * zfm_hj &
+                            &                ) * vmask(ji,jj,ikbv)
+            END DO
+         END DO
+      ENDIF
+
+      ! Corrective barotropic velocity (times hor. scale factor)
+      zbu(:,:) = zbu(:,:)/ (zhu_b(:,:)*umask(:,:,1)+1._wp-umask(:,:,1))
+      zbv(:,:) = zbv(:,:)/ (zhv_b(:,:)*vmask(:,:,1)+1._wp-vmask(:,:,1))
+
+      CALL lbc_lnk( zbu(:,:), 'U', -1. )
+      CALL lbc_lnk( zbv(:,:), 'V', -1. )
+      CALL lbc_lnk( zwx, 'U', -1. )   ;   CALL lbc_lnk( zwy, 'V', -1. )         ! Lateral boundary conditions
+      
+      ! Set corrective fluxes in upstream direction:
+      !
+      zwx(:,:,:) = 0.e0
+      zwy(:,:,:) = 0.e0
+      DO jj = 1, jpjm1
+         DO ji = 1, fs_jpim1   ! vector opt.
+            ! upstream scheme
+            zfp_ui = zbu(ji,jj) + ABS( zbu(ji,jj) )
+            zfm_ui = zbu(ji,jj) - ABS( zbu(ji,jj) )
+            zfp_vj = zbv(ji,jj) + ABS( zbv(ji,jj) )
+            zfm_vj = zbv(ji,jj) - ABS( zbv(ji,jj) )
+            DO jk = 1, jpkm1
+               zfp_hi = fse3t_b(ji  ,jj  ,jk)
+               zfm_hi = fse3t_b(ji+1,jj  ,jk)
+               !
+               zwx(ji,jj,jk) = 0.5 * ( zfp_ui * zfp_hi + zfm_ui * zfm_hi ) * umask(ji,jj,jk)
+
+               zfp_hj = fse3t_b(ji  ,jj  ,jk)
+               zfm_hj = fse3t_b(ji  ,jj+1,jk)
+               !
+               zwy(ji,jj,jk) = 0.5 * ( zfp_vj * zfp_hj + zfm_vj * zfm_hj ) * vmask(ji,jj,jk)
+            END DO
+         END DO
+      END DO
+
+      IF ( .NOT.ln_sco ) THEN
+      ! Bottom correction:
+      DO jj = 1, jpjm1
+         DO ji = 1, fs_jpim1   ! vector opt.
+            ! upstream scheme
+            ikbu = mbku(ji,jj)
+            ikbv = mbkv(ji,jj)
+            !
+            zfp_ui = zbu(ji,jj) + ABS( zbu(ji,jj) )
+            zfm_ui = zbu(ji,jj) - ABS( zbu(ji,jj) )
+            zfp_vj = zbv(ji,jj) + ABS( zbv(ji,jj) )
+            zfm_vj = zbv(ji,jj) - ABS( zbv(ji,jj) )
+            !
+            zfp_hi = MAX(hu_b(ji,jj) - fsdepw_b(ji  ,jj  ,ikbu), 0._wp)
+            zfm_hi = MAX(hu_b(ji,jj) - fsdepw_b(ji+1,jj  ,ikbu), 0._wp)
+            !
+            zwx(ji,jj,ikbu) = 0.5 * ( zfp_ui * zfp_hi + zfm_ui * zfm_hi )
+            !
+            zfp_hj = MAX(hv_b(ji,jj) - fsdepw_b(ji  ,jj  ,ikbv), 0._wp)
+            zfm_hj = MAX(hv_b(ji,jj) - fsdepw_b(ji  ,jj+1,ikbv), 0._wp)
+            !
+            zwy(ji,jj,ikbv) = 0.5 * ( zfp_vj * zfp_hj + zfm_vj * zfm_hj )
+         END DO
+      END DO
+      ENDIF
+
+      CALL lbc_lnk( zwx, 'U', -1. )   ;   CALL lbc_lnk( zwy, 'V', -1. )         ! Lateral boundary conditions
+
+      un_td(:,:,:) = un_td(:,:,:) + zwx(:,:,:)
+      vn_td(:,:,:) = vn_td(:,:,:) + zwy(:,:,:)
+      !
+      ! Update trend with corrective fluxes:
+      DO jk = 1, jpkm1
+         DO jj = 2, jpjm1
+            DO ji = fs_2, fs_jpim1   ! vector opt.  
+               !
+               zbtr = r1_e12t(ji,jj)
+               ! total advective trends
+               ztra = - zbtr * (  zwx(ji,jj,jk) - zwx(ji-1,jj  ,jk  )   &
+                  &             + zwy(ji,jj,jk) - zwy(ji  ,jj-1,jk  ) )
+               ! add them to the general tracer trends
+               pta(ji,jj,jk) = pta(ji,jj,jk) + ztra
+            END DO
+         END DO
+      END DO
+
+      CALL wrk_dealloc( jpi, jpj, zhu_b, zhv_b, zbu, zbv)
+      CALL wrk_dealloc( jpi, jpj, jpk, zwx, zwy, zwi)
+      !
+      IF( nn_timing == 1 )  CALL timing_stop('dom_vvl_adv_fct')
+      !
+   END SUBROUTINE dom_vvl_adv_fct
+
+   SUBROUTINE nonosc_2d( pbef, paa, pbb, paft, p2dt )
+      !!---------------------------------------------------------------------
+      !!                    ***  ROUTINE nonosc_2d  ***
+      !!     
+      !! **  Purpose :   compute monotonic thickness fluxes from the upstream 
+      !!       scheme and the before field by a nonoscillatory algorithm 
+      !!
+      !! **  Method  :   ... ???
+      !!       warning : pbef and paft must be masked, but the boundaries
+      !!       conditions on the fluxes are not necessary zalezak (1979)
+      !!       drange (1995) multi-dimensional forward-in-time and upstream-
+      !!       in-space based differencing for fluid
+      !!----------------------------------------------------------------------
+      !
+      !!----------------------------------------------------------------------
+      REAL(wp)                         , INTENT(in   ) ::   p2dt            ! vertical profile of tracer time-step
+      REAL(wp), DIMENSION (jpi,jpj,jpk), INTENT(in   ) ::   pbef, paft      ! before & after field
+      REAL(wp), DIMENSION (jpi,jpj,jpk), INTENT(inout) ::   paa, pbb        ! monotonic fluxes in the 3 directions
+      !
+      INTEGER ::   ji, jj, jk   ! dummy loop indices
+      REAL(wp) ::   zpos, zneg, zbt, za, zb, zc, zbig, zrtrn, z2dtt   ! local scalars
+      REAL(wp) ::   zau, zbu, zcu, zav, zbv, zcv, zup, zdo            !   -      -
+      REAL(wp) ::   zupip1, zupim1, zupjp1, zupjm1, zupb, zupa
+      REAL(wp) ::   zdoip1, zdoim1, zdojp1, zdojm1, zdob, zdoa
+      REAL(wp), POINTER, DIMENSION(:,:,:) :: zbetup, zbetdo, zbup, zbdo
+      !!----------------------------------------------------------------------
+      !
+      IF( nn_timing == 1 )  CALL timing_start('nonosc2')
+      !
+      CALL wrk_alloc( jpi, jpj, jpk, zbetup, zbetdo, zbup, zbdo )
+      !
+
+      zbig  = 1.e+40_wp
+      zrtrn = 1.e-15_wp
+      zbetup(:,:,jpk) = 0._wp   ;   zbetdo(:,:,jpk) = 0._wp
+
+
+      ! Search local extrema
+      ! --------------------
+      ! max/min of pbef & paft with large negative/positive value (-/+zbig) inside land
+      zbup = MAX( pbef * tmask - zbig * ( 1.e0 - tmask ),   &
+         &        paft * tmask - zbig * ( 1.e0 - tmask )  )
+      zbdo = MIN( pbef * tmask + zbig * ( 1.e0 - tmask ),   &
+         &        paft * tmask + zbig * ( 1.e0 - tmask )  )
+
+      DO jk = 1, jpkm1
+         z2dtt = p2dt
+         DO jj = 2, jpjm1
+            DO ji = fs_2, fs_jpim1   ! vector opt.
+
+               ! search maximum in neighbourhood
+               zup = MAX(  zbup(ji  ,jj  ,jk  ),   &
+                  &        zbup(ji-1,jj  ,jk  ), zbup(ji+1,jj  ,jk  ),   &
+                  &        zbup(ji  ,jj-1,jk  ), zbup(ji  ,jj+1,jk  ))
+
+               ! search minimum in neighbourhood
+               zdo = MIN(  zbdo(ji  ,jj  ,jk  ),   &
+                  &        zbdo(ji-1,jj  ,jk  ), zbdo(ji+1,jj  ,jk  ),   &
+                  &        zbdo(ji  ,jj-1,jk  ), zbdo(ji  ,jj+1,jk  ))
+
+               ! positive part of the flux
+               zpos = MAX( 0., paa(ji-1,jj  ,jk  ) ) - MIN( 0., paa(ji  ,jj  ,jk  ) )   &
+                  & + MAX( 0., pbb(ji  ,jj-1,jk  ) ) - MIN( 0., pbb(ji  ,jj  ,jk  ) )   
+
+               ! negative part of the flux
+               zneg = MAX( 0., paa(ji  ,jj  ,jk  ) ) - MIN( 0., paa(ji-1,jj  ,jk  ) )   &
+                  & + MAX( 0., pbb(ji  ,jj  ,jk  ) ) - MIN( 0., pbb(ji  ,jj-1,jk  ) )
+
+               ! up & down beta terms
+               zbt = e1t(ji,jj) * e2t(ji,jj) / z2dtt
+               zbetup(ji,jj,jk) = ( zup            - paft(ji,jj,jk) ) / ( zpos + zrtrn ) * zbt
+               zbetdo(ji,jj,jk) = ( paft(ji,jj,jk) - zdo            ) / ( zneg + zrtrn ) * zbt
+            END DO
+         END DO
+      END DO
+
+      CALL lbc_lnk( zbetup, 'T', 1. )   ;   CALL lbc_lnk( zbetdo, 'T', 1. )   ! lateral boundary cond. (unchanged sign)
+
+      ! 3. monotonic flux in the i & j direction (paa & pbb)
+      ! ----------------------------------------
+      DO jk = 1, jpkm1
+         DO jj = 2, jpjm1
+            DO ji = fs_2, fs_jpim1   ! vector opt.
+               zau = MIN( 1.e0, zbetdo(ji,jj,jk), zbetup(ji+1,jj,jk) )
+               zbu = MIN( 1.e0, zbetup(ji,jj,jk), zbetdo(ji+1,jj,jk) )
+               zcu =       ( 0.5  + SIGN( 0.5 , paa(ji,jj,jk) ) )
+               paa(ji,jj,jk) = paa(ji,jj,jk) * ( zcu * zau + ( 1.e0 - zcu) * zbu )
+
+               zav = MIN( 1.e0, zbetdo(ji,jj,jk), zbetup(ji,jj+1,jk) )
+               zbv = MIN( 1.e0, zbetup(ji,jj,jk), zbetdo(ji,jj+1,jk) )
+               zcv =       ( 0.5  + SIGN( 0.5 , pbb(ji,jj,jk) ) )
+               pbb(ji,jj,jk) = pbb(ji,jj,jk) * ( zcv * zav + ( 1.e0 - zcv) * zbv )
+            END DO
+         END DO
+      END DO
+      CALL lbc_lnk( paa, 'U', -1. )   ;   CALL lbc_lnk( pbb, 'V', -1. )   ! lateral boundary condition (changed sign)
+      !
+      CALL wrk_dealloc( jpi, jpj, jpk, zbetup, zbetdo, zbup, zbdo )
+      !
+      IF( nn_timing == 1 )  CALL timing_stop('nonosc2')
+      !
+   END SUBROUTINE nonosc_2d
+
    !!======================================================================
 END MODULE domvvl
-
-
-
